func='-1000*y + 3000 -2000*exp(-x)';
f=inline(func,'x','y');
y0=0;
%step size
h=0.01;
% Implicit Euler method
xt=[0:h:10];
N=length(xt);
yt=zeros(N,1);
yt(1)=y0;
for n=2:N    
    yt(n)=(yt(n-1)+ 3000*h - 2000*h*exp(-xt(n)))/(1+1000*h);
end
hold off
a=plot(xt,yt,'g');
set(a,'Linewidth',2)
a=title(['dy/dx = f(x,y) = ' func]);
set(a,'Fontsize',16);
a=xlabel('x');
set(a,'Fontsize',14);
a=ylabel('y');
set(a,'Fontsize',14);
a=legend(['Implicit Euler - h = ' num2str(h)]);
set(a,'Fontsize',14);


